<?php

/**
 * @package     JohnCMS
 * @link        http://johncms.com
 * @copyright   Copyright (C) 2008-2011 JohnCMS Community
 * @license     LICENSE.txt (see attached file)
 * @version     VERSION.txt (see attached file)
 * @author      http://johncms.com/about
 */

define('_IN_JOHNCMS', 1);

require('../incfiles/core.php');
$lng_profile = core::load_lng('profile');

/*
-----------------------------------------------------------------
Закрываем от неавторизованных юзеров
-----------------------------------------------------------------
*/
if (!$user_id) {
    require('../incfiles/head.php');
    echo functions::display_error($lng['access_guest_forbidden']);
    require('../incfiles/end.php');
    exit;
}

/*
-----------------------------------------------------------------
Получаем данные пользователя
-----------------------------------------------------------------
*/
$user = functions::get_user($user);
if (!$user) {
    require('../incfiles/head.php');
    echo functions::display_error($lng['user_does_not_exist']);
    require('../incfiles/end.php');
    exit;
}

/*
-----------------------------------------------------------------
Переключаем режимы работы
-----------------------------------------------------------------
*/
$array = array(
    'status'  => 'includes/profile',
    'activity'  => 'includes/profile',
    'ban'       => 'includes/profile',
    'edit'      => 'includes/profile',
    'images'    => 'includes/profile',
    'info'      => 'includes/profile',
    'ip'        => 'includes/profile',
    'guestbook' => 'includes/profile',
    'recovery'  => 'includes/profile',
    'karma'     => 'includes/profile',
    'office'    => 'includes/profile',
    'password'  => 'includes/profile',
    'reset'     => 'includes/profile',
    'settings'  => 'includes/profile',
    'stat'      => 'includes/profile',
    'mails'      => 'includes/profile',
    'ava_ust'          => 'includes/album',
    'friends'   => 'includes/profile'
);
$path = !empty($array[$act]) ? $array[$act] . '/' : '';
if (array_key_exists($act, $array) && file_exists($path . $act . '.php')) {
    require_once($path . $act . '.php');
} else {
    /*
    -----------------------------------------------------------------
    Анкета пользователя
    -----------------------------------------------------------------
    */
    $headmod = 'profile,' . $user['id'];
    $textl = $lng['profile'] . ': ' . htmlspecialchars($user['name']);
    require('../incfiles/head.php');
    echo '<div class="phdr"><b>' . ($user['id'] != $user_id ? $lng_profile['user_profile'] : $lng_profile['my_profile']) . '</b></div>';

    // Меню анкеты
    $menu = array();
    if ($user['id'] == $user_id || $rights == 9 || ($rights == 7 && $rights > $user['rights'])) {
        $menu[] = '<a href="profile.php?act=edit&amp;user=' . $user['id'] . '">' . $lng['edit'] . ' анкету</a>';
    }
    if ($user['id'] != $user_id && $rights >= 7 && $rights > $user['rights']) {
        $menu[] = '<a href="' . $set['homeurl'] . '/' . $set['admp'] . '/index.php?act=usr_del&amp;id=' . $user['id'] . '">' . $lng['delete'] . '</a>';
    }
    if ($user['id'] != $user_id && $rights > $user['rights']) {
        $menu[] = '<a href="profile.php?act=ban&amp;mod=do&amp;user=' . $user['id'] . '">' . $lng['ban_do'] . '</a>';
    }
    if (!empty($menu)) {
        echo '<div class="topmenu">' . functions::display_menu($menu) . '</div>';
    }

    //Уведомление о дне рожденья
    if ($user['dayb'] == date('j', time()) && $user['monthb'] == date('n', time())) {
        echo '<div class="gmenu">' . $lng['birthday'] . '!!!</div>';
    }

    // Информация о юзере
    $arg = array(
        'lastvisit' => 1,
        'iphist'    => 1,
        'header'    => '<b>ID:' . $user['id'] . '</b>'
    );

    if ($user['id'] != core::$user_id) {
        $arg['footer'] = '<span class="gray">' . core::$lng['where'] . ':</span> ' . functions::display_place($user['id'], $user['place']);
    }
    

    // Если юзер ожидает подтверждения регистрации, выводим напоминание
    if ($rights >= 7 && !$user['preg'] && empty($user['regadm'])) {
        echo '<div class="rmenu">' . $lng_profile['awaiting_registration'] . '</div>';
    }

 echo '<div class="user">';   
// Данные пользователя
    // запросы для Магазина Сайта 
        $clr = mysql_fetch_assoc(mysql_query("SELECT `cnick`,`cstat` FROM `users` WHERE `id`='".$user['id']."'"));
        $cnick = $clr['cnick']; 
        $cstat = $clr['cstat']; 
        
if ($user['sex'])
                if (file_exists((ROOTPATH . 'files/users/avatar/' . $user['id'] . '.png')))
                    echo '<img src="../files/users/avatar/' . $user['id'] . '.png" width="16" height="16" alt="" />&#160;';
                    else
                    echo '' . functions::image(($user['sex'] == 'm' ? 'm' : 'w') . ($user['datereg'] > time() - 86400 ? '_new' : '') . '.png', array('class' => 'icon-inline'));
// Ник юзера и ссылка на его анкету
if ($user_id && $user_id != $res['user_id']) {
    echo '<font color="'.$cnick.'"><b>' . $user['name'] . '</b></font>';
}
// Метка должности
$rank = array(
    0 => '(Обычный юзер)',
    1 => '(Модер галерея)',
    2 => '(Модер чата)',
    3 => '(Модер форума)',
    4 => '(Модер по загрузкам)',
    5 => '(Модер стати)',
    6 => '(Супермодератор)',
    7 => '(Администратор)',
    9 => '(Создател)'
);
echo ' ' . $rank[$user['rights']];
            echo '' . (time() > $user['lastdate'] + 300 ? '<img src="/images/offline.png" alt="offline" />' : '<img src="/images/online.png" alt="online" />');
 if (!empty($arg['header']))
                echo '' . $arg['header'];
if (!isset($arg['stshide']) && !empty($user['status']))
// status
echo '<div class="st_1"></div><div class="st_2">' . functions::image('label.png', array('class' => 'icon-inline')) . '&#160;'.(strlen($cstat) == 1 ? '' . $user['status'] . '' : '<font style="color: '.$cstat.'">' . $user['status'] . '</font>').'[<a href="/shop/index.php?act=status"><img src="/images/edit.gif" alt="" />ред</a>]</div>'; 
else

if ($user['id'] != $user_id) { 
}else{ 
echo '<div class="st_1"></div><div class="st_2">Ваш статус [<a href="/shop/index.php?act=status"><img src="/images/edit.gif" alt="" />ред</a>]</div>'; 
} 

if ($user['id'] != $user_id) { 
}else{ 
echo '<center><a href="album.php?act=ava_ust"><img src="../images/phota_gl.png" />Установить аватар</a></center>';
} 
if (file_exists('../files/users/photo/' . $user['id'] . '_small.jpg'))
    echo '<center><img src="../files/users/photo/' . $user['id'] . '_small.jpg" alt="' . $user['name'] . '"  boart="96" /><br /><a href="../files/users/photo/' . $user['id'] . '.jpg"><img src="../images/phota_gl.png" /> Увеличит</a></center>';
    else
    echo '<center><img src="/images/empty.png" width="96" height="96" alt="" /></center>&#160;';
    echo '<br/><b>' . core::$lng['where'] . ':</b> ' . functions::display_place($user['id'], $user['place']);
$arg = array( 
'lastvisit' => 1 
); 
echo '<br/>Монета:&#160;<b>'.$user['balans'].'</b>' ;
 echo '</div>'; 

    // Карма
    if ($set_karma['on']) {
        $karma = $user['karma_plus'] - $user['karma_minus'];
        if ($karma > 0) {
            $images = ($user['karma_minus'] ? ceil($user['karma_plus'] / $user['karma_minus']) : $user['karma_plus']) > 10 ? '2' : '1';
            echo '<div class="list2">';
        } else if ($karma < 0) {
            $images = ($user['karma_plus'] ? ceil($user['karma_minus'] / $user['karma_plus']) : $user['karma_minus']) > 10 ? '-2' : '-1';
            echo '<div class="rmenu">';
        } else {
            $images = 0;
            echo '<div class="list2">';
        }
        echo '<table  width="100%"><tr><td width="22" valign="top"><img src="' . $set['homeurl'] . '/images/k_' . $images . '.gif"/></td><td>' .
            '<b><span style="color: #32CD32;">' . $lng['karma'] . ' (' . $karma . ')</span></b>' .
            '<div class="sub">' .
            '<span class="green">' . functions::image('za.png') . '<a href="profile.php?act=karma&amp;user=' . $user['id'] . '&amp;type=1"><span style="color: #32CD32;">' . $lng['vote_for'] . ' (' . $user['karma_plus'] . ')</span></a></span> | ' .
            '<span class="red">' . functions::image('protiv.png') . '<a href="profile.php?act=karma&amp;user=' . $user['id'] . '">' . $lng['vote_against'] . ' (' . $user['karma_minus'] . ')</a></span>';
        if ($user['id'] != $user_id) {
            if (!$datauser['karma_off'] && (!$user['rights'] || ($user['rights'] && !$set_karma['adm'])) && $user['ip'] != $datauser['ip']) {
                $sum = mysql_result(mysql_query("SELECT SUM(`points`) FROM `karma_users` WHERE `user_id` = '$user_id' AND `time` >= '" . $datauser['karma_time'] . "'"), 0);
                $count = mysql_result(mysql_query("SELECT COUNT(*) FROM `karma_users` WHERE `user_id` = '$user_id' AND `karma_user` = '" . $user['id'] . "' AND `time` > '" . (time() - 86400) . "'"), 0);
                if (!$ban && $datauser['postforum'] >= $set_karma['forum'] && $datauser['total_on_site'] >= $set_karma['karma_time'] && ($set_karma['karma_points'] - $sum) > 0 && !$count) {
                    echo '<br /><a href="profile.php?act=karma&amp;mod=vote&amp;user=' . $user['id'] . '">' . $lng['vote'] . '</a>';
                }
            }
        } else {
            $total_karma = mysql_result(mysql_query("SELECT COUNT(*) FROM `karma_users` WHERE `karma_user` = '$user_id' AND `time` > " . (time() - 86400)), 0);
            if ($total_karma > 0) {
                echo '<br /><a href="profile.php?act=karma&amp;mod=new">' . $lng['responses_new'] . '</a> (' . $total_karma . ')';
            }
        }
        echo '</div></td></tr></table></div>';
    }
    
   // Меню выбора
        //Стикеры
$znachki = mysql_fetch_array(mysql_query("SELECT * FROM `stick_true` WHERE `user_id` = '".$user['id']."'"));
if (isset($znachki['user_id']) AND $znachki['stick_id'] >= 1) {
if ((time() - $znachki['time']) > 604800) mysql_query("UPDATE `stick_true` SET `stick_id` = '0', `time` = '0' WHERE `user_id` = '".$user['id']."'");
echo '<span style="float : right;"><a href="'.$home.'/users/stickers.php"><img src="'.$home.'/users/stickers/'.$znachki['stick_id'].'.png" alt="'.$znachki['stick_id'].'" border="0"/></a></span>';
} 
    $total_photo = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_album_files` WHERE `user_id` = '" . $user['id'] . "'"), 0);
    echo '<div class="list2">' .
        '<div>' . functions::image('contacts.png') . '<a href="profile.php?act=info&amp;user=' . $user['id'] . '">' . $lng['information'] . ' [ID: ' . $user['id'] . ']</a></div>';
    $bancount = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_ban_users` WHERE `user_id` = '" . $user['id'] . "'"), 0);

    if ($bancount) {
        echo '<div><img src="../images/block.gif" width="16" height="16"/>&#160;<a href="profile.php?act=ban&amp;user=' . $user['id'] . '">' . $lng['infringements'] . '</a> (' . $bancount . ')</div>';
    }

    $total_friends = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_contact` WHERE `user_id`='{$user['id']}' AND `type`='2' AND `friends`='1'"), 0);
    echo '' .
        '<div>' . functions::image('photo.gif') . '<a href="album.php?act=list&amp;user=' . $user['id'] . '">' . $lng['photo_album'] . '</a>&#160;(' . $total_photo . ')</div>' .
        '<div>' . functions::image('guestbook.gif') . '<a href="profile.php?act=guestbook&amp;user=' . $user['id'] . '">' . $lng['stena'] . '</a>&#160;(' . $user['comm_count'] . ')</div>' .
        '<div>' . functions::image('users.png') . '<a href="profile.php?act=friends&amp;user=' . $user['id'] . '">' . $lng_profile['friends'] . '</a>&#160;(' . $total_friends . ')</div>' .
        '</div>';
$i = $user['id']; 
$my_art = mysql_fetch_array(mysql_query("SELECT `avtor_id` FROM `lib` WHERE `avtor_id`=$i")); 
if (isset($my_art['avtor_id'])) {
echo "<div class='list2'><img src='/library/icons/article.gif' alt='' /><a href='../library/index.php?act=his&amp;avtor=$i'>Статьи пользователя</a></div>";
}  

          
        // Контакты
            if ($user['id'] != $user_id) {
        echo '<div class="rmenu">';
        if (!functions::is_ignor($user['id']) && functions::is_contact($user['id']) != 2) {
            if (!functions::is_friend($user['id'])) {
                $fr_in = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_contact` WHERE `type`='2' AND `from_id`='$user_id' AND `user_id`='{$user['id']}'"), 0);
                $fr_out = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_contact` WHERE `type`='2' AND `user_id`='$user_id' AND `from_id`='{$user['id']}'"), 0);
                if ($fr_in == 1) {
                    $friend = '<a class="underline" href="profile.php?act=friends&amp;do=ok&amp;id=' . $user['id'] . '">' . $lng_profile['confirm_friendship'] . '</a> | <a class="underline" href="profile.php?act=friends&amp;do=no&amp;id=' . $user['id'] . '">' . $lng_profile['decline_friendship'] . '</a>';
                } else if ($fr_out == 1) {
                    $friend = '<a class="underline" href="profile.php?act=friends&amp;do=cancel&amp;id=' . $user['id'] . '">' . $lng_profile['canceled_demand_friend'] . '</a>';
                } else {
                    $friend = '<a href="profile.php?act=friends&amp;do=add&amp;id=' . $user['id'] . '">' . $lng_profile['in_friend'] . '</a>';
                }
            } else {
                $friend = '<a href="profile.php?act=friends&amp;do=delete&amp;id=' . $user['id'] . '">' . $lng_profile['remov_friend'] . '</a>';
            }
            echo '<div>' . functions::image('add.gif') . $friend . '</div>';
        }

        if (functions::is_contact($user['id']) != 2) {
            if (!functions::is_contact($user['id'])) {
                echo '<div><img src="../images/users.png" width="16" height="16"/>&#160;<a href="../mail/index.php?id=' . $user['id'] . '">' . $lng_profile['add_contacts'] . '</a></div>';
            } else {
                echo '<div><img src="../images/users.png" width="16" height="16"/>&#160;<a href="../mail/index.php?act=deluser&amp;id=' . $user['id'] . '">' . $lng_profile['delete_contacts'] . '</a></div>';
            }
        }

        if (functions::is_contact($user['id']) != 2) {
            echo '<div><img src="../images/del.png" width="16" height="16"/>&#160;<a href="../mail/index.php?act=ignor&amp;id=' . $user['id'] . '&amp;add">' . $lng_profile['add_ignor'] . '</a></div>';
        } else {
            echo '<div><img src="../images/del.png" width="16" height="16"/>&#160;<a href="../mail/index.php?act=ignor&amp;id=' . $user['id'] . '&amp;del">' . $lng_profile['delete_ignor'] . '</a></div>';
        }
        if (!functions::is_ignor($user['id']) && functions::is_contact($user['id']) != 2 && empty($ban['1']) && empty($ban['3'])) {
            echo '<div><img src="../images/mail-inbox.png" width="16" height="16"/>&#160;<a href="../mail/index.php?act=write&amp;id=' . $user['id'] . '" method="post">' . $lng['write'] . ' письмо</a></div>';
            echo '<div><img src="../images/coins.gif" width="16" height="16"/>&#160;<a href="/shop/money.php?user=' . $user['id'] . '">Перевести монеты</a></div>';
        }
        echo '</div>';
              }  

        // stena
        $context_top = '<div class="phdr">' . $lng['stena'] . '</div>';

/*
-----------------------------------------------------------------
Параметры Гостевой
-----------------------------------------------------------------
*/
$arg = array (
    'comments_table' => 'cms_users_guestbook', // Таблица Гостевой
    'object_table' => 'users',                 // Таблица комментируемых объектов
    'script' => 'profile.php?act=guestbook',   // Имя скрипта (с параметрами вызова)
    'sub_id_name' => 'user',                   // Имя идентификатора комментируемого объекта
    'sub_id' => $user['id'],                   // Идентификатор комментируемого объекта
    'owner' => $user['id'],                    // Владелец объекта
    'owner_delete' => true,                    // Возможность владельцу удалять комментарий
    'owner_reply' => true,                     // Возможность владельцу отвечать на комментарий
    'title' => $lng['comments'],               // Название раздела
    'context_top' => $context_top              // Выводится вверху списка
);

/*
-----------------------------------------------------------------
Показываем комментарии
-----------------------------------------------------------------
*/
$comm = new comments($arg);

/*
-----------------------------------------------------------------
Обновляем счетчик непрочитанного
-----------------------------------------------------------------
*/
if(!$mod && $user['id'] == $user_id && $user['comm_count'] != $user['comm_old']){
    mysql_query("UPDATE `users` SET `comm_old` = '" . $user['comm_count'] . "' WHERE `id` = '$user_id'");
}
    echo '<div class="phdr"><a href="index.php">' . $lng['users'] . '</a></div>';
}

require_once('../incfiles/end.php');